51eef2026facb72c0881167007beaca5f55c0141
[oota-llvm.git] / utils / release / test-release.sh
1 #!/usr/bin/env bash
2 #===-- test-release.sh - Test the LLVM release candidates ------------------===#
3 #
4 #                     The LLVM Compiler Infrastructure
5 #
6 # This file is distributed under the University of Illinois Open Source
7 # License.
8 #
9 #===------------------------------------------------------------------------===#
10 #
11 # Download, build, and test the release candidate for an LLVM release.
12 #
13 #===------------------------------------------------------------------------===#
14
15 if [ `uname -s` = "FreeBSD" ]; then
16     MAKE=gmake
17 else
18     MAKE=make
19 fi
20
21 # Base SVN URL for the sources.
22 Base_url="http://llvm.org/svn/llvm-project"
23
24 Release=""
25 Release_no_dot=""
26 RC=""
27 Triple=""
28 use_gzip="no"
29 do_checkout="yes"
30 do_debug="no"
31 do_asserts="no"
32 do_compare="yes"
33 do_rt="yes"
34 do_libs="yes"
35 do_libunwind="yes"
36 do_test_suite="yes"
37 do_openmp="yes"
38 BuildDir="`pwd`"
39 use_autoconf="no"
40 ExtraConfigureFlags=""
41 ExportBranch=""
42
43 function usage() {
44     echo "usage: `basename $0` -release X.Y.Z -rc NUM [OPTIONS]"
45     echo ""
46     echo " -release X.Y.Z       The release version to test."
47     echo " -rc NUM              The pre-release candidate number."
48     echo " -final               The final release candidate."
49     echo " -triple TRIPLE       The target triple for this machine."
50     echo " -j NUM               Number of compile jobs to run. [default: 3]"
51     echo " -build-dir DIR       Directory to perform testing in. [default: pwd]"
52     echo " -no-checkout         Don't checkout the sources from SVN."
53     echo " -test-debug          Test the debug build. [default: no]"
54     echo " -test-asserts        Test with asserts on. [default: no]"
55     echo " -no-compare-files    Don't test that phase 2 and 3 files are identical."
56     echo " -use-gzip            Use gzip instead of xz."
57     echo " -configure-flags FLAGS  Extra flags to pass to the configure step."
58     echo " -use-autoconf        Use autoconf instead of cmake"
59     echo " -svn-path DIR        Use the specified DIR instead of a release."
60     echo "                      For example -svn-path trunk or -svn-path branches/release_37"
61     echo " -no-rt               Disable check-out & build Compiler-RT"
62     echo " -no-libs             Disable check-out & build libcxx/libcxxabi/libunwind"
63     echo " -no-libunwind        Disable check-out & build libunwind"
64     echo " -no-test-suite       Disable check-out & build test-suite"
65     echo " -no-openmp           Disable check-out & build libomp"
66 }
67
68 if [ `uname -s` = "Darwin" ]; then
69   # compiler-rt doesn't yet build with CMake on Darwin.
70   use_autoconf="yes"
71 fi
72
73 while [ $# -gt 0 ]; do
74     case $1 in
75         -release | --release )
76             shift
77             Release="$1"
78             Release_no_dot="`echo $1 | sed -e 's,\.,,g'`"
79             ;;
80         -rc | --rc | -RC | --RC )
81             shift
82             RC="rc$1"
83             ;;
84         -final | --final )
85             RC=final
86             ;;
87         -svn-path | --svn-path )
88             shift
89             Release="test"
90             Release_no_dot="test"
91             ExportBranch="$1"
92             RC="`echo $ExportBranch | sed -e 's,/,_,g'`"
93             echo "WARNING: Using the branch $ExportBranch instead of a release tag"
94             echo "         This is intended to aid new packagers in trialing "
95             echo "         builds without requiring a tag to be created first"
96             ;;
97         -triple | --triple )
98             shift
99             Triple="$1"
100             ;;
101         -configure-flags | --configure-flags )
102             shift
103             ExtraConfigureFlags="$1"
104             ;;
105         -j* )
106             NumJobs="`echo $1 | sed -e 's,-j\([0-9]*\),\1,g'`"
107             if [ -z "$NumJobs" ]; then
108                 shift
109                 NumJobs="$1"
110             fi
111             ;;
112         -build-dir | --build-dir | -builddir | --builddir )
113             shift
114             BuildDir="$1"
115             ;;
116         -no-checkout | --no-checkout )
117             do_checkout="no"
118             ;;
119         -test-debug | --test-debug )
120             do_debug="yes"
121             ;;
122         -test-asserts | --test-asserts )
123             do_asserts="yes"
124             ;;
125         -no-compare-files | --no-compare-files )
126             do_compare="no"
127             ;;
128         -use-gzip | --use-gzip )
129             use_gzip="yes"
130             ;;
131         -use-autoconf | --use-autoconf )
132             use_autoconf="yes"
133             ;;
134         -no-rt )
135             do_rt="no"
136             ;;
137         -no-libs )
138             do_libs="no"
139             ;;
140         -no-libunwind )
141             do_libunwind="no"
142             ;;
143         -no-test-suite )
144             do_test_suite="no"
145             ;;
146         -no-openmp )
147             do_openmp="no"
148             ;;
149         -help | --help | -h | --h | -\? )
150             usage
151             exit 0
152             ;;
153         * )
154             echo "unknown option: $1"
155             usage
156             exit 1
157             ;;
158     esac
159     shift
160 done
161
162 if [ "$use_autoconf" = "no" ]; then
163   # See llvm.org/PR26146.
164   echo Skipping test-suite when using CMake.
165   do_test_suite="no"
166 fi
167
168 # Check required arguments.
169 if [ -z "$Release" ]; then
170     echo "error: no release number specified"
171     exit 1
172 fi
173 if [ -z "$RC" ]; then
174     echo "error: no release candidate number specified"
175     exit 1
176 fi
177 if [ -z "$ExportBranch" ]; then
178     ExportBranch="tags/RELEASE_$Release_no_dot/$RC"
179 fi
180 if [ -z "$Triple" ]; then
181     echo "error: no target triple specified"
182     exit 1
183 fi
184
185 # Figure out how many make processes to run.
186 if [ -z "$NumJobs" ]; then
187     NumJobs=`sysctl -n hw.activecpu 2> /dev/null || true`
188 fi
189 if [ -z "$NumJobs" ]; then
190     NumJobs=`sysctl -n hw.ncpu 2> /dev/null || true`
191 fi
192 if [ -z "$NumJobs" ]; then
193     NumJobs=`grep -c processor /proc/cpuinfo 2> /dev/null || true`
194 fi
195 if [ -z "$NumJobs" ]; then
196     NumJobs=3
197 fi
198
199 # Projects list
200 projects="llvm cfe clang-tools-extra"
201 if [ $do_rt = "yes" ]; then
202   projects="$projects compiler-rt"
203 fi
204 if [ $do_libs = "yes" ]; then
205   projects="$projects libcxx libcxxabi"
206   if [ $do_libunwind = "yes" ]; then
207     projects="$projects libunwind"
208   fi
209 fi
210 if [ $do_test_suite = "yes" ]; then
211   projects="$projects test-suite"
212 fi
213 if [ $do_openmp = "yes" ]; then
214   projects="$projects openmp"
215 fi
216
217 # Go to the build directory (may be different from CWD)
218 BuildDir=$BuildDir/$RC
219 mkdir -p $BuildDir
220 cd $BuildDir
221
222 # Location of log files.
223 LogDir=$BuildDir/logs
224 mkdir -p $LogDir
225
226 # Final package name.
227 Package=clang+llvm-$Release
228 if [ $RC != "final" ]; then
229   Package=$Package-$RC
230 fi
231 Package=$Package-$Triple
232
233 # Errors to be highlighted at the end are written to this file.
234 echo -n > $LogDir/deferred_errors.log
235
236 function deferred_error() {
237   Phase="$1"
238   Flavor="$2"
239   Msg="$3"
240   echo "[${Flavor} Phase${Phase}] ${Msg}" | tee -a $LogDir/deferred_errors.log
241 }
242
243 # Make sure that a required program is available
244 function check_program_exists() {
245   local program="$1"
246   if ! type -P $program > /dev/null 2>&1 ; then
247     echo "program '$1' not found !"
248     exit 1
249   fi
250 }
251
252 if [ `uname -s` != "Darwin" ]; then
253   check_program_exists 'chrpath'
254   check_program_exists 'file'
255   check_program_exists 'objdump'
256 fi
257
258 # Make sure that the URLs are valid.
259 function check_valid_urls() {
260     for proj in $projects ; do
261         echo "# Validating $proj SVN URL"
262
263         if ! svn ls $Base_url/$proj/$ExportBranch > /dev/null 2>&1 ; then
264             echo "$proj does not have a $ExportBranch branch/tag!"
265             exit 1
266         fi
267     done
268 }
269
270 # Export sources to the build directory.
271 function export_sources() {
272     check_valid_urls
273
274     for proj in $projects ; do
275         if [ -d $proj.src ]; then
276           echo "# Reusing $proj $Release-$RC sources"
277           continue
278         fi
279         echo "# Exporting $proj $Release-$RC sources"
280         if ! svn export -q $Base_url/$proj/$ExportBranch $proj.src ; then
281             echo "error: failed to export $proj project"
282             exit 1
283         fi
284     done
285
286     echo "# Creating symlinks"
287     cd $BuildDir/llvm.src/tools
288     if [ ! -h clang ]; then
289         ln -s ../../cfe.src clang
290     fi
291
292     # The autoconf and CMake builds want different symlinks here:
293     if [ "$use_autoconf" = "yes" ]; then
294       cd $BuildDir/llvm.src/tools/clang/tools
295       if [ ! -h extra ]; then
296           ln -s ../../../../clang-tools-extra.src extra
297       fi
298     else
299       cd $BuildDir/cfe.src/tools
300       if [ ! -h extra ]; then
301           ln -s ../../clang-tools-extra.src extra
302       fi
303     fi
304
305     cd $BuildDir/llvm.src/projects
306     if [ -d $BuildDir/test-suite.src ] && [ ! -h test-suite ]; then
307         ln -s ../../test-suite.src test-suite
308     fi
309     if [ -d $BuildDir/compiler-rt.src ] && [ ! -h compiler-rt ]; then
310         ln -s ../../compiler-rt.src compiler-rt
311     fi
312     if [ -d $BuildDir/openmp.src ] && [ ! -h openmp ]; then
313         ln -s ../../openmp.src openmp
314     fi
315     if [ -d $BuildDir/libcxx.src ] && [ ! -h libcxx ]; then
316         ln -s ../../libcxx.src libcxx
317     fi
318     if [ -d $BuildDir/libcxxabi.src ] && [ ! -h libcxxabi ]; then
319         ln -s ../../libcxxabi.src libcxxabi
320     fi
321     if [ -d $BuildDir/libunwind.src ] && [ ! -h libunwind ]; then
322         ln -s ../../libunwind.src libunwind
323     fi
324
325     cd $BuildDir
326 }
327
328 function configure_llvmCore() {
329     Phase="$1"
330     Flavor="$2"
331     ObjDir="$3"
332
333     case $Flavor in
334         Release )
335             BuildType="Release"
336             Assertions="OFF"
337             ConfigureFlags="--enable-optimized --disable-assertions"
338             ;;
339         Release+Asserts )
340             BuildType="Release"
341             Assertions="ON"
342             ConfigureFlags="--enable-optimized --enable-assertions"
343             ;;
344         Debug )
345             BuildType="Debug"
346             Assertions="ON"
347             ConfigureFlags="--disable-optimized --enable-assertions"
348             ;;
349         * )
350             echo "# Invalid flavor '$Flavor'"
351             echo ""
352             return
353             ;;
354     esac
355
356     echo "# Using C compiler: $c_compiler"
357     echo "# Using C++ compiler: $cxx_compiler"
358
359     cd $ObjDir
360     echo "# Configuring llvm $Release-$RC $Flavor"
361
362     if [ "$use_autoconf" = "yes" ]; then
363         echo "#" env CC="$c_compiler" CXX="$cxx_compiler" \
364             $BuildDir/llvm.src/configure \
365             $ConfigureFlags --disable-timestamps $ExtraConfigureFlags \
366             2>&1 | tee $LogDir/llvm.configure-Phase$Phase-$Flavor.log
367         env CC="$c_compiler" CXX="$cxx_compiler" \
368             $BuildDir/llvm.src/configure \
369             $ConfigureFlags --disable-timestamps $ExtraConfigureFlags \
370             2>&1 | tee $LogDir/llvm.configure-Phase$Phase-$Flavor.log
371     else
372         echo "#" env CC="$c_compiler" CXX="$cxx_compiler" \
373             cmake -G "Unix Makefiles" \
374             -DCMAKE_BUILD_TYPE=$BuildType -DLLVM_ENABLE_ASSERTIONS=$Assertions \
375             -DLLVM_ENABLE_TIMESTAMPS=OFF -DLLVM_CONFIGTIME="(timestamp not enabled)" \
376             $ExtraConfigureFlags $BuildDir/llvm.src \
377             2>&1 | tee $LogDir/llvm.configure-Phase$Phase-$Flavor.log
378         env CC="$c_compiler" CXX="$cxx_compiler" \
379             cmake -G "Unix Makefiles" \
380             -DCMAKE_BUILD_TYPE=$BuildType -DLLVM_ENABLE_ASSERTIONS=$Assertions \
381             -DLLVM_ENABLE_TIMESTAMPS=OFF -DLLVM_CONFIGTIME="(timestamp not enabled)" \
382             $ExtraConfigureFlags $BuildDir/llvm.src \
383             2>&1 | tee $LogDir/llvm.configure-Phase$Phase-$Flavor.log
384     fi
385
386     cd $BuildDir
387 }
388
389 function build_llvmCore() {
390     Phase="$1"
391     Flavor="$2"
392     ObjDir="$3"
393     DestDir="$4"
394
395     cd $ObjDir
396     echo "# Compiling llvm $Release-$RC $Flavor"
397     echo "# ${MAKE} -j $NumJobs VERBOSE=1"
398     ${MAKE} -j $NumJobs VERBOSE=1 \
399         2>&1 | tee $LogDir/llvm.make-Phase$Phase-$Flavor.log
400
401     echo "# Installing llvm $Release-$RC $Flavor"
402     echo "# ${MAKE} install"
403     ${MAKE} install \
404         DESTDIR="${DestDir}" \
405         2>&1 | tee $LogDir/llvm.install-Phase$Phase-$Flavor.log
406     cd $BuildDir
407 }
408
409 function test_llvmCore() {
410     Phase="$1"
411     Flavor="$2"
412     ObjDir="$3"
413
414     cd $ObjDir
415     if ! ( ${MAKE} -j $NumJobs -k check-all \
416         2>&1 | tee $LogDir/llvm.check-Phase$Phase-$Flavor.log ) ; then
417       deferred_error $Phase $Flavor "check-all failed"
418     fi
419
420     if [ "$use_autoconf" = "yes" ]; then
421         # In the cmake build, unit tests are run as part of check-all.
422         if ! ( ${MAKE} -k unittests 2>&1 | \
423             tee $LogDir/llvm.unittests-Phase$Phase-$Flavor.log ) ; then
424           deferred_error $Phase $Flavor "unittests failed"
425         fi
426     fi
427
428     cd $BuildDir
429 }
430
431 # Clean RPATH. Libtool adds the build directory to the search path, which is
432 # not necessary --- and even harmful --- for the binary packages we release.
433 function clean_RPATH() {
434   if [ `uname -s` = "Darwin" ]; then
435     return
436   fi
437   local InstallPath="$1"
438   for Candidate in `find $InstallPath/{bin,lib} -type f`; do
439     if file $Candidate | grep ELF | egrep 'executable|shared object' > /dev/null 2>&1 ; then
440       if rpath=`objdump -x $Candidate | grep 'RPATH'` ; then
441         rpath=`echo $rpath | sed -e's/^ *RPATH *//'`
442         if [ -n "$rpath" ]; then
443           newrpath=`echo $rpath | sed -e's/.*\(\$ORIGIN[^:]*\).*/\1/'`
444           chrpath -r $newrpath $Candidate 2>&1 > /dev/null 2>&1
445         fi
446       fi
447     fi
448   done
449 }
450
451 # Create a package of the release binaries.
452 function package_release() {
453     cwd=`pwd`
454     cd $BuildDir/Phase3/Release
455     mv llvmCore-$Release-$RC.install/usr/local $Package
456     if [ "$use_gzip" = "yes" ]; then
457       tar cfz $BuildDir/$Package.tar.gz $Package
458     else
459       tar cfJ $BuildDir/$Package.tar.xz $Package
460     fi
461     mv $Package llvmCore-$Release-$RC.install/usr/local
462     cd $cwd
463 }
464
465 # Exit if any command fails
466 # Note: pipefail is necessary for running build commands through
467 # a pipe (i.e. it changes the output of ``false | tee /dev/null ; echo $?``)
468 set -e
469 set -o pipefail
470
471 if [ "$do_checkout" = "yes" ]; then
472     export_sources
473 fi
474
475 (
476 Flavors="Release"
477 if [ "$do_debug" = "yes" ]; then
478     Flavors="Debug $Flavors"
479 fi
480 if [ "$do_asserts" = "yes" ]; then
481     Flavors="$Flavors Release+Asserts"
482 fi
483
484 for Flavor in $Flavors ; do
485     echo ""
486     echo ""
487     echo "********************************************************************************"
488     echo "  Release:     $Release-$RC"
489     echo "  Build:       $Flavor"
490     echo "  System Info: "
491     echo "    `uname -a`"
492     echo "********************************************************************************"
493     echo ""
494
495     c_compiler="$CC"
496     cxx_compiler="$CXX"
497     llvmCore_phase1_objdir=$BuildDir/Phase1/$Flavor/llvmCore-$Release-$RC.obj
498     llvmCore_phase1_destdir=$BuildDir/Phase1/$Flavor/llvmCore-$Release-$RC.install
499
500     llvmCore_phase2_objdir=$BuildDir/Phase2/$Flavor/llvmCore-$Release-$RC.obj
501     llvmCore_phase2_destdir=$BuildDir/Phase2/$Flavor/llvmCore-$Release-$RC.install
502
503     llvmCore_phase3_objdir=$BuildDir/Phase3/$Flavor/llvmCore-$Release-$RC.obj
504     llvmCore_phase3_destdir=$BuildDir/Phase3/$Flavor/llvmCore-$Release-$RC.install
505
506     rm -rf $llvmCore_phase1_objdir
507     rm -rf $llvmCore_phase1_destdir
508
509     rm -rf $llvmCore_phase2_objdir
510     rm -rf $llvmCore_phase2_destdir
511
512     rm -rf $llvmCore_phase3_objdir
513     rm -rf $llvmCore_phase3_destdir
514
515     mkdir -p $llvmCore_phase1_objdir
516     mkdir -p $llvmCore_phase1_destdir
517
518     mkdir -p $llvmCore_phase2_objdir
519     mkdir -p $llvmCore_phase2_destdir
520
521     mkdir -p $llvmCore_phase3_objdir
522     mkdir -p $llvmCore_phase3_destdir
523
524     ############################################################################
525     # Phase 1: Build llvmCore and clang
526     echo "# Phase 1: Building llvmCore"
527     configure_llvmCore 1 $Flavor $llvmCore_phase1_objdir
528     build_llvmCore 1 $Flavor \
529         $llvmCore_phase1_objdir $llvmCore_phase1_destdir
530     clean_RPATH $llvmCore_phase1_destdir/usr/local
531
532     ########################################################################
533     # Phase 2: Build llvmCore with newly built clang from phase 1.
534     c_compiler=$llvmCore_phase1_destdir/usr/local/bin/clang
535     cxx_compiler=$llvmCore_phase1_destdir/usr/local/bin/clang++
536     echo "# Phase 2: Building llvmCore"
537     configure_llvmCore 2 $Flavor $llvmCore_phase2_objdir
538     build_llvmCore 2 $Flavor \
539         $llvmCore_phase2_objdir $llvmCore_phase2_destdir
540     clean_RPATH $llvmCore_phase2_destdir/usr/local
541
542     ########################################################################
543     # Phase 3: Build llvmCore with newly built clang from phase 2.
544     c_compiler=$llvmCore_phase2_destdir/usr/local/bin/clang
545     cxx_compiler=$llvmCore_phase2_destdir/usr/local/bin/clang++
546     echo "# Phase 3: Building llvmCore"
547     configure_llvmCore 3 $Flavor $llvmCore_phase3_objdir
548     build_llvmCore 3 $Flavor \
549         $llvmCore_phase3_objdir $llvmCore_phase3_destdir
550     clean_RPATH $llvmCore_phase3_destdir/usr/local
551
552     ########################################################################
553     # Testing: Test phase 3
554     echo "# Testing - built with clang"
555     test_llvmCore 3 $Flavor $llvmCore_phase3_objdir
556
557     ########################################################################
558     # Compare .o files between Phase2 and Phase3 and report which ones
559     # differ.
560     if [ "$do_compare" = "yes" ]; then
561         echo
562         echo "# Comparing Phase 2 and Phase 3 files"
563         for p2 in `find $llvmCore_phase2_objdir -name '*.o'` ; do
564             p3=`echo $p2 | sed -e 's,Phase2,Phase3,'`
565             # Substitute 'Phase2' for 'Phase3' in the Phase 2 object file in
566             # case there are build paths in the debug info. On some systems,
567             # sed adds a newline to the output, so pass $p3 through sed too.
568             if ! cmp -s <(sed -e 's,Phase2,Phase3,g' $p2) <(sed -e '' $p3) \
569                     16 16 ; then
570                 echo "file `basename $p2` differs between phase 2 and phase 3"
571             fi
572         done
573     fi
574 done
575
576 ) 2>&1 | tee $LogDir/testing.$Release-$RC.log
577
578 package_release
579
580 set +e
581
582 # Woo hoo!
583 echo "### Testing Finished ###"
584 if [ "$use_gzip" = "yes" ]; then
585   echo "### Package: $Package.tar.gz"
586 else
587   echo "### Package: $Package.tar.xz"
588 fi
589 echo "### Logs: $LogDir"
590
591 echo "### Errors:"
592 if [ -s "$LogDir/deferred_errors.log" ]; then
593   cat "$LogDir/deferred_errors.log"
594   exit 1
595 else
596   echo "None."
597 fi
598
599 exit 0